Bug 1775816 - glibc: Disable libio vtable validation for interposed pre-2.1 stdio handles [rhel-7]
Summary: glibc: Disable libio vtable validation for interposed pre-2.1 stdio handles [...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.9
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 7.9
Assignee: Florian Weimer
QA Contact: qe-baseos-tools-bugs
URL:
Whiteboard:
Depends On:
Blocks: 1782202
TreeView+ depends on / blocked
 
Reported: 2019-11-22 21:18 UTC by Florian Weimer
Modified: 2020-09-29 19:21 UTC (History)
8 users (show)

Fixed In Version: glibc-2.17-314.el7
Doc Type: No Doc Update
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-09-29 19:20:26 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Bugzilla 1775819 0 unspecified CLOSED glibc: Disable libio vtable validation for interposed pre-2.1 stdio handles [rhel-8] 2021-02-22 00:41:40 UTC
Red Hat Product Errata RHSA-2020:3861 0 None None None 2020-09-29 19:21:09 UTC
Sourceware 25203 0 P2 RESOLVED Disable libio vtable validation for interposed pre-2.1 stdio handles 2020-08-31 08:06:59 UTC

Internal Links: 1775819

Description Florian Weimer 2019-11-22 21:18:58 UTC
Bug 1595191 only fixed binaries linked against glibc 2.1 or later. The legacy stdio implementation in libio/oldstdfiles.c needs a similar check for interposition.

Comment 1 Carlos O'Donell 2019-12-09 14:14:10 UTC
commit cb61630ed712d033f54295f776967532d3f4b46a
Author: Florian Weimer <fweimer@redhat.com>
Date:   Fri Nov 22 22:10:42 2019 +0100

    libio: Disable vtable validation for pre-2.1 interposed handles [BZ #25203]
    
    Commit c402355dfa7807b8e0adb27c009135a7e2b9f1b0 ("libio: Disable
    vtable validation in case of interposition [BZ #23313]") only covered
    the interposable glibc 2.1 handles, in libio/stdfiles.c.  The
    parallel code in libio/oldstdfiles.c needs similar detection logic.
    
    Fixes (again) commit db3476aff19b75c4fdefbe65fcd5f0a90588ba51
    ("libio: Implement vtable verification [BZ #20191]").
    
    Change-Id: Ief6f9f17e91d1f7263421c56a7dc018f4f595c21

Comment 4 Sergey Kolosov 2020-06-19 12:30:38 UTC
Verified with Counter Strike server. It fails on glibc-2.17-313.el7 with "Fatal error: glibc detected an invalid stdio handle" and it runs on glibc-2.17-314.el7.

Comment 6 errata-xmlrpc 2020-09-29 19:20:26 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (Low: glibc security, bug fix, and enhancement update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2020:3861


Note You need to log in before you can comment on or make changes to this bug.